using System;
using System.Web;

namespace Mtp2Dav.WebDAVSharp.Server._1d2086a502937936ebc6bfe19cfa15d855be1c31.Stores.BaseClasses
{
    /// <summary>
    ///     This is the base class for <see cref="IWebDavStoreItem" /> implementations.
    /// </summary>
    public class WebDavStoreDocumentBase : WebDavStoreItemBase
    {
        /// <summary>
        ///     Initializes a new instance of the <see cref="WebDavStoreItemBase" /> class.
        /// </summary>
        /// <param name="path">The name of this <see cref="IWebDavStoreItem" /></param>
        /// <exception cref="ArgumentNullException"><paramref name="path" /> is <c>null</c>.</exception>
        protected WebDavStoreDocumentBase(string path) : base(path)
        {
        }

        #region IWebDAVStoreItem Members

        /// <summary>
        ///     Gets or sets the mime type of this <see cref="IWebDavStoreItem" />.
        /// </summary>
        /// <value>
        ///     The type of the MIME.
        /// </value>
        public string MimeType => MimeMapping.GetMimeMapping(Name);

        #endregion
    }
}