using System;
using WebDAVSharp.Server.Stores;

namespace RamDavisk.Ramfs
{
    internal abstract class WebDavRamfsStoreItem : IWebDavStoreItem, IDisposable
    {
        protected WebDavRamfsStoreItem()
        {
            CreationDate = DateTime.Now;
            ModificationDate = CreationDate;
        }

        // hold

        IWebDavStoreCollection IWebDavStoreItem.ParentCollection => ParentCollection;
        public string ItemPath => (ParentCollection?.ItemPath ?? "") + "/" + Name;

        public WebDavRamfsStoreCollection ParentCollection { get; set; }
        public string Name { get; set; } = "";

        public DateTime CreationDate { get; }
        public DateTime ModificationDate { get; protected set; }

        // abstr

        public abstract long Size { get; }

        public abstract bool IsCollection { get; }

        public abstract string Etag { get; }

        //virtual

        public virtual void Dispose()
        {
        }

        // unused

        public Uri Href { get; set; }

        public string MimeType { get; }

        public IWebDavStore Store { get; }

        public Guid GetRepl_uId()
        {
            return new Guid();
        }

        public IWebDavFileInfo GetFileInfo()
        {
            return new WebDavRamfsStoreFileInfo()
            {
            };
        }
    }
}