using System;

namespace Utilities
{
    public abstract class FileSystemEntry : IFileSystemEntry
    {
        // hold

        public string Name { get; set; }
        public DateTime CreationTime { get; set; }
        public DateTime LastWriteTime { get; set; }
        public DateTime LastAccessTime { get; set; }
        public bool IsHidden { get; set; }
        public bool IsReadonly { get; set; }
        public bool IsArchived { get; set; }

        // abst

        public abstract bool IsDirectory { get; }
        public abstract ulong Size { get; }

        // impl

        public IFileSystemEntry Clone()
        {
            return (IFileSystemEntry)MemberwiseClone();
        }
    }
}